<template>
  <div class="upload-file">
    <el-upload
      multiple
      :action="uploadFileUrl"
      :before-upload="handleBeforeUpload"
      :file-list="fileList"
      :limit="limit"
      :on-error="handleUploadError"
      :on-exceed="handleExceed"
      :on-success="handleUploadSuccess"
      :show-file-list="false"
      :headers="headers"
      class="upload-file-uploader"
      ref="fileUpload"
    >
      <!-- 上传按钮 -->
      <el-button size="mini" type="primary">选取文件</el-button>
      <!-- 上传提示 -->
      <div class="el-upload__tip" slot="tip" v-if="showTip">
        请上传
        <template v-if="fileSize">
          大小不超过 <b style="color: #f56c6c">{{ fileSize }}MB</b>
        </template>
        <template v-if="fileType">
          格式为 <b style="color: #f56c6c">{{ fileType.join('/') }}</b>
        </template>
        的文件
      </div>
    </el-upload>

    <!-- 文件列表 -->
    <transition-group class="upload-file-list el-upload-list el-upload-list--text" name="el-fade-in-linear" tag="ul">
      <li :key="file.url" class="el-upload-list__item ele-upload-list__item-content" v-for="(file, index) in fileList">
        <el-link :href="`${file.url}`" :underline="false" target="_blank">
          <span class="el-icon-document"> {{ file.fileName }} </span>
        </el-link>
        <div class="ele-upload-list__item-content-action">
          <el-link :underline="false" @click="handleDelete(index)" type="danger">删除</el-link>
        </div>
      </li>
    </transition-group>
  </div>
</template>

<script>
import { getToken } from '@/utils/auth'
import { getItem } from '@/utils/index'
import { getListByIdsApi, delOssApi } from '@/api/als/oss'

export default {
  name: 'FileUpload',
  props: {
    // 值
    value: [String, Object, Array],
    // 数量限制
    limit: {
      type: Number,
      default: 5
    },
    // 大小限制(MB)
    fileSize: {
      type: Number,
      default: 100
    },
    // 文件类型, 例如['png', 'jpg', 'jpeg']
    fileType: {
      type: Array
    },
    // 是否飞参数据名称校验
    isNameCheck: {
      type: Boolean,
      default: false
    },
    // 飞机型号类型
    isAirType: {
      type: String,
      default: ''
    },
    // 是否显示提示
    isShowTip: {
      type: Boolean,
      default: true
    },
    uploadSuccess: {
      type: Function,
      default: null
    }
  },
  data() {
    return {
      number: 0,
      uploadList: [],
      // baseUrl: '/api',
      uploadFileUrl: '/api/als/resource/oss/upload',
      headers: { Authorization: getItem('token') },
      fileList: [],
      loading: null
    }
  },
  watch: {
    value: {
      async handler(val) {
        if (val) {
          let temp = 1
          // 首先将值转为数组
          let list = []
          if (Array.isArray(val)) {
            list = val
          } else {
            const res = await getListByIdsApi(val)
            list = res.data.map((oss) => {
              return {
                fileName: oss.originalName,
                url: oss.url,
                ossId: oss.ossId
              }
            })
          }
          // 然后将数组转为对象数组
          this.fileList = list.map((item) => {
            item = { fileName: item.fileName, url: item.url, ossId: item.ossId }
            item.uid = item.uid || new Date().getTime() + temp++
            return item
          })
        } else {
          this.fileList = []
          return []
        }
      },
      deep: true,
      immediate: true
    }
  },
  computed: {
    // 是否显示提示
    showTip() {
      return this.isShowTip && (this.fileType || this.fileSize)
    }
  },
  methods: {
    // 上传前校检格式和大小
    handleBeforeUpload(file) {
      // 校检文件类型
      if (this.fileType) {
        const fileName = file.name.split('.')
        const fileExt = fileName[fileName.length - 1]
        const isTypeOk = this.fileType.indexOf(fileExt) >= 0
        if (!isTypeOk) {
          this.$message({
            type: 'error',
            message: `文件格式不正确, 请上传${this.fileType.join('/')}格式文件!`
          })
          return false
        }
      }
      // 校检文件大小
      if (this.fileSize) {
        const isLt = file.size / 1024 / 1024 < this.fileSize
        if (!isLt) {
          this.$message({
            type: 'error',
            message: `上传文件大小不能超过 ${this.fileSize} MB!`
          })
          return false
        }
      }
      // 校验飞参数据名称是否符合
      if (this.isNameCheck) {
        const name = file.name.split('.')
        const fileName = name.slice(0, name.length - 1)
        if (fileName.length !== 1) {
          this.$message({
            type: 'error',
            message: '上传文件名称不符合规则!'
          })
          return false
        } else {
          if (this.isAirType === 'KJ') {
            const airTime = fileName[0].split('_')[0]
            const isTime = this.isValidDateTime(airTime)
            if (!isTime) {
              this.$message({
                type: 'error',
                message: '上传文件名称不符合规则!'
              })
              return false
            }
          } else if (this.isAirType === 'J') {
            const airTime = fileName[0].split('_').slice(-2).join('')
            const isTime = this.isValidDateTime(airTime)
            if (!isTime) {
              this.$message({
                type: 'error',
                message: '上传文件名称不符合规则!'
              })
              return false
            }
          }
        }
      }
      this.loading = this.$loading({
        lock: true,
        text: '正在上传文件，请稍候...',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      this.number++
      return true
    },

    // 判断是否为时间
    isValidDateTime(str) {
      // 正则表达式匹配规则
      const regex = /^\d{4}(0[1-9]|1[0-2])(0[1-9]|[12]\d|3[01])([01]\d|2[0-3])[0-5]\d[0-5]\d$/

      if (!regex.test(str)) {
        return false // 字符串格式不正确
      }

      // 提取日期时间部分
      const year = parseInt(str.substring(0, 4), 10)
      const month = parseInt(str.substring(4, 6), 10)
      const day = parseInt(str.substring(6, 8), 10)
      const hour = parseInt(str.substring(8, 10), 10)
      const minute = parseInt(str.substring(10, 12), 10)
      const second = parseInt(str.substring(12, 14), 10)

      // 创建日期对象，检查日期是否有效
      const date = new Date(year, month - 1, day, hour, minute, second)

      // 检查日期的年月日时分秒是否与输入的字符串匹配
      if (date.getFullYear() === year && date.getMonth() + 1 === month && date.getDate() === day && date.getHours() === hour && date.getMinutes() === minute && date.getSeconds() === second) {
        return true
      }

      return false
    },

    // 文件个数超出
    handleExceed() {
      this.$message({
        type: 'error',
        message: `上传文件数量不能超过 ${this.limit} 个!`
      })
    },
    // 上传失败
    handleUploadError(err) {
      this.$message({
        type: 'error',
        message: '上传文件失败，请重试'
      })
      this.loading.close()
    },
    // 上传成功回调
    handleUploadSuccess(res, file) {
      if (res.code === 200) {
        this.uploadList.push({ fileName: res.data.fileName, url: res.data.url, ossId: res.data.ossId })
        if (this.isNameCheck) {
          this.$emit('uploadValue', this.uploadList)
        }
        this.uploadedSuccessfully()
      } else {
        this.number--
        this.loading.close()
        this.$message({
          type: 'error',
          message: res.msg
        })
        this.$refs.fileUpload.handleRemove(file)
        this.uploadedSuccessfully()
      }
    },
    // 删除文件
    handleDelete(index) {
      let ossId = this.fileList[index].ossId
      delOssApi(ossId)
      this.fileList.splice(index, 1)
      this.$emit('input', this.fileList)
    },
    // 上传结束处理
    uploadedSuccessfully() {
      if (this.number > 0 && this.uploadList.length === this.number) {
        this.fileList = this.fileList.concat(this.uploadList)
        this.uploadList = []
        this.number = 0
        this.$emit('input', this.fileList[this.number].ossId)
        this.loading.close()
      }
    },
    // 获取文件名称
    getFileName(name) {
      if (name.lastIndexOf('/') > -1) {
        return name.slice(name.lastIndexOf('/') + 1)
      } else {
        return ''
      }
    },
    // 对象转成指定字符串分隔
    listToString(list, separator) {
      let strs = ''
      separator = separator || ','
      for (let i in list) {
        strs += list[i].url + separator
      }
      return strs != '' ? strs.substr(0, strs.length - 1) : ''
    }
  }
}
</script>

<style scoped lang="scss">
.upload-file-uploader {
  margin-bottom: 5px;
}
.upload-file-list .el-upload-list__item {
  border: 1px solid #e4e7ed;
  line-height: 2;
  margin-bottom: 10px;
  position: relative;
}
.upload-file-list .ele-upload-list__item-content {
  display: flex;
  justify-content: space-between;
  align-items: center;
  color: inherit;
}
.ele-upload-list__item-content-action .el-link {
  margin-right: 10px;
}
</style>
